

TYPE S3DVertex
  x AS SINGLE
  y AS SINGLE
  z AS SINGLE
  nx AS SINGLE
  ny AS SINGLE
  nz AS SINGLE
  ccolor AS LONG
  tu AS SINGLE
  tv AS SINGLE
END TYPE

TYPE S3DVertex2TCoords
  x  AS SINGLE
  y  AS SINGLE
  z  AS SINGLE
  nx  AS SINGLE
  ny  AS SINGLE
  nz  AS SINGLE
  ccolor AS LONG
  tu1  AS SINGLE
  tv1  AS SINGLE
  tu2  AS SINGLE
  tv2  AS SINGLE
END TYPE

TYPE S3DVertexTangents
  x  AS SINGLE
  y  AS SINGLE
  z  AS SINGLE
  nx  AS SINGLE
  ny  AS SINGLE
  nz  AS SINGLE
  ccolor AS LONG
  tu  AS SINGLE
  tv  AS SINGLE
  tangx  AS SINGLE
  tangy  AS SINGLE
  tangz  AS SINGLE
  binormx  AS SINGLE
  binormy  AS SINGLE
  binormz  AS SINGLE
END TYPE


TYPE NewtonHingeSliderUpdateDesc
    m_accel  AS SINGLE
    m_minFriction  AS SINGLE
    m_maxFriction  AS SINGLE
    m_timestep  AS SINGLE
END TYPE



MACRO Mesh = DWORD PTR

MACRO AnimatedMesh = DWORD PTR

MACRO EntityNode = DWORD PTR

MACRO PivotNode = DWORD PTR

MACRO CameraNode = DWORD PTR

MACRO LightNode = DWORD PTR

MACRO VolumeLightNode = DWORD PTR

MACRO TextNode = DWORD PTR

MACRO ParticleSystemNode = DWORD PTR

MACRO ParticleEmitter = DWORD PTR

MACRO BillboardNode = DWORD PTR

MACRO TerrainNode = DWORD PTR

MACRO TerrainSphereNode = DWORD PTR

MACRO AnimatedNode = DWORD PTR

MACRO BoneNod = DWORD PTR

MACRO ShadowVolumeNode = DWORD PTR

MACRO SpriteSceneNode = DWORD PTR

MACRO Sprite2D = DWORD PTR

MACRO MeshBuffer = DWORD PTR

MACRO NSceneNodeAnimator = DWORD PTR

MACRO NNodeAnimator = DWORD PTR

MACRO NAnimatorCollisionResponse = DWORD PTR

MACRO BoneNode = DWORD PTR

MACRO NMaterial = DWORD PTR

MACRO NTexture = DWORD PTR

MACRO NImage = DWORD PTR

MACRO NArray = DWORD PTR

MACRO NMaterialServices = DWORD PTR

MACRO NReadFile = DWORD PTR

MACRO NWriteFile = DWORD PTR

MACRO NFileList = DWORD PTR

'-----------------------------
' GUI
MACRO IGUIFont              = DWORD PTR

MACRO IGUIElement           = DWORD PTR

MACRO IGUICheckBox          = DWORD PTR

MACRO IGUIButton            = DWORD PTR

MACRO IGUIEditBox           = DWORD PTR

MACRO IGUIImage             = DWORD PTR

MACRO IGUIComboBox          = DWORD PTR

MACRO IGUIContextMenu       = DWORD PTR

MACRO IGUIFileOpenDialog    = DWORD PTR

MACRO IGUIInOutFader        = DWORD PTR

MACRO IGUIListBox           = DWORD PTR

MACRO IGUIWindow            = DWORD PTR

MACRO IGUIScrollBar         = DWORD PTR

MACRO IGUISpinBox           = DWORD PTR

MACRO IGUITab               = DWORD PTR

MACRO IGUITabControl        = DWORD PTR

MACRO IGUIStaticText        = DWORD PTR

MACRO IGUITable             = DWORD PTR

MACRO IGUIToolBar           = DWORD PTR

MACRO IGUIProgressBar       = DWORD PTR

MACRO IGUISkin              = DWORD PTR

MACRO CCustomGUISkin        = DWORD PTR

MACRO IGUISpriteBank        = DWORD PTR


' physic part
MACRO NBodySceneNode        = DWORD PTR

MACRO NMaterialPair         = DWORD PTR

MACRO NPMaterial            = DWORD PTR

MACRO NJoint                = DWORD PTR

' physic body
MACRO NBody                 = DWORD PTR



TYPE iVECTOR2
  x  AS SINGLE
  y  AS SINGLE
END TYPE
TYPE iVECTOR3
  x  AS SINGLE
  y  AS SINGLE
  z  AS SINGLE
END TYPE
TYPE iPLANE
        ' Normal vector of the plane.
        Normal AS iVECTOR3
        ' Distance from origin.
        D  AS SINGLE
END TYPE
TYPE iAABBOX
        min AS iVECTOR3
        max AS iVECTOR3
END TYPE

'key event
TYPE SKeyMap
    Action AS LONG
    KeyCode AS LONG
END TYPE
