' wrap physic


' ------------------------------------------------------------------------------------------------------------------------
'- Global
' ------------------------------------------------------------------------------------------------------------------------

'declare Sub _SolverModelPhysic(byval  mode as Integer=1)
DECLARE SUB SolverModelPhysic CDECL LIB "N3xtD.dll" ALIAS "_SolverModelPhysic"(OPT BYVAL  MODE_ AS LONG)

'declare Sub _PlatformArchitecturePhysic(byval  mode as Integer=0)
DECLARE SUB PlatformArchitecturePhysic CDECL LIB "N3xtD.dll" ALIAS "_PlatformArchitecturePhysic"(OPT BYVAL MODE_ AS LONG)

'declare Sub _FrictionModelPhysic(byval  model as Integer=0)
DECLARE SUB FrictionModelPhysic  CDECL LIB "N3xtD.dll" ALIAS "_FrictionModelPhysic"(OPT BYVAL  model AS LONG)

DECLARE SUB DestroyAllBodies CDECL LIB "N3xtD.dll" ALIAS "_DestroyAllBodies"()

DECLARE SUB FreePhysic CDECL LIB "N3xtD.dll" ALIAS "_FreePhysic"()
DECLARE SUB InitPhysic CDECL LIB "N3xtD.dll" ALIAS "_InitPhysic"()

' declare Sub _UpdatePhysic(byval tTimer as Single=60.0)
DECLARE SUB UpdatePhysic CDECL LIB "N3xtD.dll" ALIAS "_UpdatePhysic"(OPT BYVAL tTimer AS SINGLE)

DECLARE SUB SetWorldSize CDECL LIB "N3xtD.dll" ALIAS "_SetWorldSize"(BYVAL minx AS SINGLE, BYVAL miny AS SINGLE, BYVAL minz AS SINGLE, _
    BYVAL maxx AS SINGLE, BYVAL maxy AS SINGLE, BYVAL maxz AS SINGLE)

DECLARE SUB GravityForce CDECL LIB "N3xtD.dll" ALIAS "_GravityForce"(BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)

'declare Sub _TimerUpdatePhysic(byval tTimer as Single = 60.0)

DECLARE SUB TimerUpdatePhysic CDECL LIB "N3xtD.dll" ALIAS "_TimerUpdatePhysic"(BYVAL tTimer AS SINGLE)

' ------------------------------------------------------------------------------------------------------------------------
'- RIGID BODY
' ------------------------------------------------------------------------------------------------------------------------
'declare Function _CreateBody(byval ent As EntityNode, byval typeForm as Integer=BOX_PRIMITIVE , byval dynamique As UByte=True,
'byval mass as single=1.0, byval vx as single=0, byval vy as single=0, byval vz as Single=0)As NBody
DECLARE FUNCTION CreateBody CDECL LIB "N3xtD.dll" ALIAS "_CreateBody"(BYVAL ent AS EntityNode, OPT BYVAL typeForm AS LONG, _
    OPT BYVAL dynamique AS BYTE, OPT BYVAL mass AS SINGLE, OPT BYVAL vx AS SINGLE, OPT BYVAL vy AS SINGLE, OPT BYVAL vz AS SINGLE) AS DWORD 'NBody

'declare Function _CreateTerrainBody(byval terrain As TerrainNode, byval tType as Integer=HEIGHTFIELD_METHOD)As NBody
DECLARE FUNCTION CreateTerrainBody CDECL LIB "N3xtD.dll" ALIAS "_CreateTerrainBody"(BYVAL terrain AS TerrainNode, OPT BYVAL tType AS LONG)AS DWORD ''NBody

'declare Function _CreateBodyStaticElement(byval ent As EntityNode, byval typeForm as Integer=BOX_PRIMITIVE, byval vx as single=0, byval vy as single=0, byval vz as Single=0)As NBody
DECLARE FUNCTION CreateBodyStaticElement CDECL LIB "N3xtD.dll" ALIAS "_CreateBodyStaticElement"(BYVAL ent AS EntityNode, OPT BYVAL typeForm AS LONG, _
    OPT BYVAL vx AS SINGLE, OPT BYVAL vy AS SINGLE, OPT BYVAL vz AS SINGLE) AS DWORD

'declare Function _CreateBodyBatchElement(byval ent As EntityNode, byval typeForm as Integer=BOX_PRIMITIVE, byval vx as single=0, byval vy as single=0, byval vz as Single=0)As NBody
DECLARE FUNCTION CreateBodyBatchElement CDECL LIB "N3xtD.dll" ALIAS "_CreateBodyBatchElement"(BYVAL ent AS EntityNode, OPT BYVAL typeForm AS LONG, _
    OPT BYVAL vx AS SINGLE, OPT BYVAL vy AS SINGLE, OPT BYVAL vz AS SINGLE) AS DWORD 'NBody

DECLARE SUB BodyRestoreCallbacks CDECL LIB "N3xtD.dll" ALIAS "_BodyRestoreCallbacks"(BYVAL node AS EntityNode)
DECLARE SUB FreeBody CDECL LIB "N3xtD.dll" ALIAS "_FreeBody"(BYVAL node AS EntityNode)
DECLARE SUB MatrixBody CDECL LIB "N3xtD.dll" ALIAS "_MatrixBody"(BYVAL node AS EntityNode, MAT_ AS ANY)
DECLARE SUB MomentOfInertiaBody CDECL LIB "N3xtD.dll" ALIAS "_MomentOfInertiaBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE,_
    BYVAL z AS SINGLE)

 DECLARE SUB MassCenterBody CDECL LIB "N3xtD.dll" ALIAS "_MassCenterBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB BodyCentreOfMass CDECL LIB "N3xtD.dll" ALIAS "_BodyCentreOfMass"(BYVAL node AS EntityNode, mass_center AS ANY)
 DECLARE SUB MassBody CDECL LIB "N3xtD.dll" ALIAS "_MassBody"(BYVAL node AS EntityNode,  BYVAL mass AS SINGLE)
 DECLARE SUB LinearDampingBody CDECL LIB "N3xtD.dll" ALIAS "_LinearDampingBody"(BYVAL node AS EntityNode, BYVAL value AS SINGLE)
 DECLARE SUB BodyMomentOfInertia CDECL LIB "N3xtD.dll" ALIAS "_BodyMomentOfInertia"(BYVAL node AS EntityNode, RES_ AS ANY)
 DECLARE SUB FreezeBody CDECL LIB "N3xtD.dll" ALIAS "_FreezeBody"(BYVAL node AS EntityNode, BYVAL value AS BYTE)
 DECLARE FUNCTION BodyFreeze CDECL LIB "N3xtD.dll" ALIAS "_BodyFreeze"(BYVAL node AS EntityNode)AS LONG
 DECLARE FUNCTION BodyMass CDECL LIB "N3xtD.dll" ALIAS "_BodyMass"(BYVAL node AS EntityNode)AS SINGLE
 DECLARE SUB AddForceBody CDECL LIB "N3xtD.dll" ALIAS "_AddForceBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB ForceBody CDECL LIB "N3xtD.dll" ALIAS "_ForceBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB AddDirectForceBody CDECL LIB "N3xtD.dll" ALIAS "_AddDirectForceBody"(BYVAL body AS NBody, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB DirectForceBody CDECL LIB "N3xtD.dll" ALIAS "_DirectForceBody"(BYVAL body AS NBody, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB AddForceContinuousBody CDECL LIB "N3xtD.dll" ALIAS "_AddForceContinuousBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, _
    BYVAL z AS SINGLE)

 DECLARE SUB AddTorqueBody CDECL LIB "N3xtD.dll" ALIAS "_AddTorqueBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB TorqueBody CDECL LIB "N3xtD.dll" ALIAS "_TorqueBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB OmegaBody CDECL LIB "N3xtD.dll" ALIAS "_OmegaBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB VelocityBody CDECL LIB "N3xtD.dll" ALIAS "_VelocityBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB CalculateMomentOfInertiaBody CDECL LIB "N3xtD.dll" ALIAS "_CalculateMomentOfInertiaBody"(BYVAL node AS EntityNode)
 DECLARE SUB BodyOmega CDECL LIB "N3xtD.dll" ALIAS "_BodyOmega"(BYVAL node AS EntityNode, omega AS ANY)
 DECLARE SUB AngularDampingBody CDECL LIB "N3xtD.dll" ALIAS "_AngularDampingBody"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
 DECLARE SUB BodyVelocity CDECL LIB "N3xtD.dll" ALIAS "_BodyVelocity"(BYVAL node AS EntityNode, velocity AS ANY)
 DECLARE SUB ContinuousCollisionModeBody CDECL LIB "N3xtD.dll" ALIAS "_ContinuousCollisionModeBody"(BYVAL node AS EntityNode,  BYVAL value AS BYTE)
 DECLARE FUNCTION BodyContinuousCollisionMode CDECL LIB "N3xtD.dll" ALIAS "_BodyContinuousCollisionMode"(BYVAL node AS EntityNode) AS LONG
 DECLARE SUB BodyPosition CDECL LIB "N3xtD.dll" ALIAS "_BodyPosition"(BYVAL node AS EntityNode, POS_ AS ANY)
 DECLARE SUB BodyRotation CDECL LIB "N3xtD.dll" ALIAS "_BodyRotation"(BYVAL node AS EntityNode, rot AS ANY)
'declare Sub _PulseBody(byval node as EntityNode, byval delta_velocityx as single, byval delta_velocityy as single, byval delta_velocityz as single, byval impulse_centerx as single=0,  byval impulse_centery as single=0,  byval impulse_centerz as Single=0)
DECLARE SUB PulseBody CDECL LIB "N3xtD.dll" ALIAS "_PulseBody"(BYVAL node AS EntityNode, BYVAL delta_velocityx AS SINGLE, BYVAL delta_velocityy AS SINGLE,_
    BYVAL delta_velocityz AS SINGLE, OPT BYVAL impulse_centerx AS SINGLE,  OPT BYVAL impulse_centery AS SINGLE, OPT BYVAL impulse_centerz AS SINGLE)

DECLARE SUB CollisionBody CDECL LIB "N3xtD.dll" ALIAS "_CollisionBody"(BYVAL node AS EntityNode, newCollision AS ANY)
DECLARE FUNCTION BodyNode CDECL LIB "N3xtD.dll" ALIAS "_BodyNode" (BYVAL node AS EntityNode) AS DWORD           'EntityNode
DECLARE SUB ApplyForceAndTorqueBody CDECL LIB "N3xtD.dll" ALIAS "_ApplyForceAndTorqueBody"(BYVAL node AS EntityNode, CALLBACK_ AS ANY)
DECLARE FUNCTION BodyCollideBody CDECL LIB "N3xtD.dll" ALIAS "_BodyCollideBody"(BYVAL node AS EntityNode)AS DWORD 'ANY PTR
DECLARE FUNCTION BodyNumCollideBody CDECL LIB "N3xtD.dll" ALIAS "_BodyNumCollideBody"(BYVAL node AS EntityNode)AS LONG
DECLARE SUB CalculateAABBBody CDECL LIB "N3xtD.dll" ALIAS "_CalculateAABBBody"(BYVAL node AS EntityNode, BOX_ AS ANY)
DECLARE SUB MatrixRecursiveBody CDECL LIB "N3xtD.dll" ALIAS "_MatrixRecursiveBody"(BYVAL node AS EntityNode, matrix AS ANY)
DECLARE SUB JointRecursiveCollisionBody CDECL LIB "N3xtD.dll" ALIAS "_JointRecursiveCollisionBody"(BYVAL node AS EntityNode, BYVAL STATE AS LONG)
DECLARE FUNCTION BodySleepState CDECL LIB "N3xtD.dll" ALIAS "_BodySleepState"(BYVAL node AS EntityNode)AS LONG
DECLARE FUNCTION BodyAutoSleep CDECL LIB "N3xtD.dll" ALIAS "_BodyAutoSleep"(BYVAL node AS EntityNode)AS LONG
DECLARE SUB AutoSleepBody CDECL LIB "N3xtD.dll" ALIAS "_AutoSleepBody"(BYVAL node AS EntityNode, BYVAL STATE AS LONG)
DECLARE FUNCTION BodyCollision CDECL LIB "N3xtD.dll" ALIAS "_BodyCollision"(BYVAL node AS EntityNode)AS DWORD 'ANY PTR
DECLARE FUNCTION BodyJointRecursiveCollision CDECL LIB "N3xtD.dll" ALIAS "_BodyJointRecursiveCollision"(BYVAL node AS EntityNode)AS LONG
DECLARE SUB BodyMatrix CDECL LIB "N3xtD.dll" ALIAS "_BodyMatrix"(BYVAL node AS EntityNode, matrix AS ANY)
DECLARE SUB BodyForce CDECL LIB "N3xtD.dll" ALIAS "_BodyForce"(BYVAL node AS EntityNode, force AS ANY)
DECLARE SUB BodyTorque CDECL LIB "N3xtD.dll" ALIAS "_BodyTorque"(BYVAL node AS EntityNode, torque AS ANY)
DECLARE FUNCTION BodyLinearDamping CDECL LIB "N3xtD.dll" ALIAS "_BodyLinearDamping"(BYVAL node AS EntityNode) AS SINGLE
DECLARE SUB BodyAngularDamping CDECL LIB "N3xtD.dll" ALIAS "_BodyAngularDamping"(BYVAL node AS EntityNode, tt AS ANY)
DECLARE SUB BodyAABB CDECL LIB "N3xtD.dll" ALIAS "_BodyAABB"(BYVAL node AS EntityNode, p0 AS ANY, p1 AS ANY)
DECLARE SUB BouyancyMaterial CDECL LIB "N3xtD.dll" ALIAS "_BouyancyMaterial"(BYVAL node AS EntityNode, BYVAL pmaterial AS NMaterialPair )

'declare Sub _BouyancyParameter(byval fluiddensity as single=0.2, byval gx as single=0, byval gy as single=-10.0, byval gz as Single=0)
DECLARE SUB BouyancyParameter CDECL LIB "N3xtD.dll" ALIAS "_BouyancyParameter"(OPT BYVAL fluiddensity AS SINGLE, OPT BYVAL gx AS SINGLE, _
    OPT BYVAL gy AS SINGLE, OPT BYVAL gz AS SINGLE)

DECLARE SUB AsTriggerVolume CDECL LIB "N3xtD.dll" ALIAS "_AsTriggerVolume"(BYVAL node AS EntityNode, BYVAL trigger AS LONG )

' ------------------------------------------------------------------------------------------------------------------------
'- COLLIDE INSTRUCTIONS
' ------------------------------------------------------------------------------------------------------------------------
DECLARE SUB FreeNodeCollide CDECL LIB "N3xtD.dll" ALIAS "_FreeNodeCollide"(BYVAL node AS EntityNode)

'declare Sub _CreateNodeCollide(byval node as EntityNode, byval typeForm as integer, byval tType as Integer,  byval vx as single=0, byval vy as single=0, byval vz as Single=0)
DECLARE SUB CreateNodeCollide CDECL LIB "N3xtD.dll" ALIAS "_CreateNodeCollide"(BYVAL node AS EntityNode, BYVAL typeForm AS LONG, BYVAL tType AS LONG, _
    OPT BYVAL vx AS SINGLE, OPT BYVAL vy AS SINGLE, OPT BYVAL vz AS SINGLE)

DECLARE SUB CreateTerrainCollide CDECL LIB "N3xtD.dll" ALIAS "_CreateTerrainCollide"(BYVAL terrain AS TerrainNode, BYVAL tType AS LONG)
DECLARE SUB CreateHeightFieldTerrainCollide CDECL LIB "N3xtD.dll" ALIAS "_CreateHeightFieldTerrainCollide"(BYVAL terrain AS TerrainNode, BYVAL tType AS LONG)
DECLARE FUNCTION NodeCollide CDECL LIB "N3xtD.dll" ALIAS "_NodeCollide"(BYVAL entA AS EntityNode, BYVAL entB AS EntityNode)AS LONG
DECLARE FUNCTION NodeCollideAll CDECL LIB "N3xtD.dll" ALIAS "_NodeCollideAll"(BYVAL node AS EntityNode)AS LONG
DECLARE FUNCTION CollidePointDistance CDECL LIB "N3xtD.dll" ALIAS "_CollidePointDistance"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, _
    BYVAL z AS SINGLE)AS LONG

'declare Function _CollideRayCast(byval node as EntityNode, byval x as single, byval y as single, byval z as single, byval dx as single, byval dy as single, byval dz as Single, byval tType as Integer=1)As Single
DECLARE FUNCTION CollideRayCast CDECL LIB "N3xtD.dll" ALIAS "_CollideRayCast"(BYVAL node AS EntityNode, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE, _
    BYVAL dx AS SINGLE, BYVAL dy AS SINGLE, BYVAL dz AS SINGLE, OPT BYVAL tType AS LONG)AS SINGLE

DECLARE FUNCTION CollideRayCastAll CDECL LIB "N3xtD.dll" ALIAS "_CollideRayCastAll"( BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE, BYVAL dx AS SINGLE, _
    BYVAL dy AS SINGLE, BYVAL dz AS SINGLE, BYVAL tType AS LONG, dist AS ANY) AS DWORD 'EntityNode

DECLARE SUB CollidePoint CDECL LIB "N3xtD.dll" ALIAS "_CollidePoint"(tri AS ANY,  BYVAL index AS LONG)
DECLARE SUB CollideNormal CDECL LIB "N3xtD.dll" ALIAS "_CollideNormal"(tri AS ANY,  BYVAL index AS LONG)

'declare Function _CollideNode(byval index as Integer=0)As EntityNode
DECLARE FUNCTION CollideNode CDECL LIB "N3xtD.dll" ALIAS "_CollideNode"(OPT BYVAL index AS LONG)AS DWORD

' ------------------------------------------------------------------------------------------------------------------------
'- MATERIAL
' ------------------------------------------------------------------------------------------------------------------------
DECLARE FUNCTION CreatePhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_CreatePhysicMaterial"()AS LONG
DECLARE FUNCTION CreatePhysicMaterialPair CDECL LIB "N3xtD.dll" ALIAS "_CreatePhysicMaterialPair"(BYVAL  mat1 AS LONG, BYVAL  mat2 AS LONG, BYVAL elasticity AS SINGLE, _
    BYVAL frictionstatic AS SINGLE, BYVAL frictiondynamic AS SINGLE, BYVAL softness AS SINGLE) AS DWORD ' Return *NMaterialPair

DECLARE SUB ElasticityPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ElasticityPhysicMaterial"(BYVAL pr AS NMaterialPair , BYVAL VAL AS SINGLE)
DECLARE SUB FrictionPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_FrictionPhysicMaterial"(BYVAL pr AS NMaterialPair, BYVAL valstatic AS SINGLE,  BYVAL valdynamic AS SINGLE)
DECLARE SUB SoftnessPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_SoftnessPhysicMaterial"(BYVAL pr AS NMaterialPair,  BYVAL vVal AS SINGLE)
DECLARE SUB GroupPhysicMaterialBody CDECL LIB "N3xtD.dll" ALIAS "_GroupPhysicMaterialBody"(BYVAL node AS EntityNode,  BYVAL MAT AS LONG)
DECLARE FUNCTION BodyPhysicMaterialGroup CDECL LIB "N3xtD.dll" ALIAS "_BodyPhysicMaterialGroup"(BYVAL node AS EntityNode)AS LONG
DECLARE SUB CollidablePhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_CollidablePhysicMaterial"(BYVAL pr AS NMaterialPair,  BYVAL STATE AS LONG)

'declare Sub _CollisionMemPhysicMaterial(byval pr as NMaterialPair, byval flag As UByte=True)
DECLARE SUB CollisionMemPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_CollisionMemPhysicMaterial"(BYVAL pr AS NMaterialPair, OPT BYVAL flag AS BYTE)

' ------------------------------------------------------------------------------------------------------------------------
'- JOINTS
' ------------------------------------------------------------------------------------------------------------------------
DECLARE SUB FreeJoint CDECL LIB "N3xtD.dll" ALIAS "_FreeJoint"(BYVAL joint AS NJoint)
DECLARE FUNCTION CreateBallJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateBallJoint"(BYVAL CHILD AS EntityNode, BYVAL PARENT AS EntityNode ,  BYVAL x AS SINGLE, _
    BYVAL y AS SINGLE,  BYVAL z AS SINGLE) AS DWORD 'NJoint

DECLARE SUB BallSetConeLimits CDECL LIB "N3xtD.dll" ALIAS "_BallSetConeLimits"(BYVAL ball AS NJoint,  BYVAL x AS SINGLE,  BYVAL y AS SINGLE,  BYVAL z AS SINGLE, _
    BYVAL maxConeAngle AS SINGLE,  BYVAL maxTwistAngle AS SINGLE)

DECLARE FUNCTION CreateHingeJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateHingeJoint"(BYVAL CHILD AS EntityNode,BYVAL PARENT AS EntityNode, BYVAL x AS SINGLE,  _
    BYVAL y AS SINGLE,  BYVAL z AS SINGLE, BYVAL dirx AS SINGLE,  BYVAL diry AS SINGLE,  BYVAL dirz AS SINGLE) AS DWORD 'NJoint

DECLARE FUNCTION CreateSliderJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateSliderJoint"(BYVAL CHILD AS EntityNode, BYVAL PARENT AS EntityNode, BYVAL x AS SINGLE, _
    BYVAL y AS SINGLE,  BYVAL z AS SINGLE, BYVAL dirx AS SINGLE,  BYVAL diry AS SINGLE,  BYVAL dirz AS SINGLE) AS DWORD 'NJoint

DECLARE FUNCTION CreateCorkScrewJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateCorkScrewJoint"(BYVAL CHILD AS EntityNode, BYVAL PARENT AS EntityNode, BYVAL x AS SINGLE, _
    BYVAL y AS SINGLE,  BYVAL z AS SINGLE, BYVAL dirx AS SINGLE,  BYVAL diry AS SINGLE,  BYVAL dirz AS SINGLE) AS DWORD 'NJoint

DECLARE FUNCTION CreateUniversalJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateUniversalJoint"(BYVAL CHILD AS EntityNode, BYVAL PARENT AS EntityNode, BYVAL x AS SINGLE, _
    BYVAL y AS SINGLE,  BYVAL z AS SINGLE, BYVAL dirx AS SINGLE,  BYVAL diry AS SINGLE,  BYVAL dirz AS SINGLE, BYVAL diox AS SINGLE,  _
    BYVAL dioy AS SINGLE,  BYVAL dioz AS SINGLE) AS DWORD 'NJoint

DECLARE FUNCTION CreateUpVectorJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateUpVectorJoint"(BYVAL node AS EntityNode, BYVAL x AS SINGLE,  BYVAL y AS SINGLE, _
    BYVAL z AS SINGLE) AS DWORD 'NJoint

DECLARE FUNCTION CreateUserJoint CDECL LIB "N3xtD.dll" ALIAS "_CreateUserJoint"(BYVAL CHILD AS EntityNode, BYVAL PARENT AS EntityNode,  BYVAL maxDOF AS LONG, _
    callback AS ANY) AS DWORD 'NJoint

DECLARE FUNCTION JointCollisionState CDECL LIB "N3xtD.dll" ALIAS "_JointCollisionState"(BYVAL joint AS NJoint)AS LONG
DECLARE SUB CollisionStateJoint CDECL LIB "N3xtD.dll" ALIAS "_CollisionStateJoint"(BYVAL joint AS NJoint,  BYVAL STATE AS LONG)
DECLARE FUNCTION JointStiffness CDECL LIB "N3xtD.dll" ALIAS "_JointStiffness"(BYVAL joint AS NJoint)AS SINGLE
DECLARE SUB StiffnessJoint CDECL LIB "N3xtD.dll" ALIAS "_StiffnessJoint"(BYVAL joint AS NJoint,  BYVAL STATE AS SINGLE)
DECLARE SUB UserCallbackBallJoint CDECL LIB "N3xtD.dll" ALIAS "_UserCallbackBallJoint"(BYVAL joint AS NJoint,  CALLBACK_ AS ANY)
DECLARE SUB BallJointAngle CDECL LIB "N3xtD.dll" ALIAS "_BallJointAngle"(BYVAL joint AS NJoint, angle AS ANY)
DECLARE SUB BallJointOmega CDECL LIB "N3xtD.dll" ALIAS "_BallJointOmega"(BYVAL joint AS NJoint, angle AS ANY)
DECLARE SUB BallJointForce CDECL LIB "N3xtD.dll" ALIAS "_BallJointForce"(BYVAL joint AS NJoint, force AS ANY)
DECLARE SUB UserCallbackHingeJoint CDECL LIB "N3xtD.dll" ALIAS "_UserCallbackHingeJoint"(BYVAL joint AS NJoint, CALLBACK_ AS ANY)
DECLARE FUNCTION HingeJointAngle CDECL LIB "N3xtD.dll" ALIAS "_HingeJointAngle"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION HingeJointOmega CDECL LIB "N3xtD.dll" ALIAS "_HingeJointOmega"(BYVAL joint AS NJoint)AS SINGLE
DECLARE SUB HingeJointForce CDECL LIB "N3xtD.dll" ALIAS "_HingeJointForce"(BYVAL joint AS NJoint, force AS ANY)
DECLARE SUB UserCallbackSliderJoint CDECL LIB "N3xtD.dll" ALIAS "_UserCallbackSliderJoint"(BYVAL joint AS NJoint,  CALLBACK_ AS ANY)
DECLARE SUB SliderJointForce CDECL LIB "N3xtD.dll" ALIAS "_SliderJointForce"(BYVAL joint AS NJoint, force AS ANY)
DECLARE FUNCTION SliderJointPosit CDECL LIB "N3xtD.dll" ALIAS "_SliderJointPosit"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION SliderJointVeloc CDECL LIB "N3xtD.dll" ALIAS "_SliderJointVeloc"(BYVAL joint AS NJoint)AS SINGLE
DECLARE SUB UserCallbackCorkscrewJoint CDECL LIB "N3xtD.dll" ALIAS "_UserCallbackCorkscrewJoint"(BYVAL joint AS NJoint, CALLBACK_ AS ANY)
DECLARE FUNCTION CorkscrewJointPosit CDECL LIB "N3xtD.dll" ALIAS "_CorkscrewJointPosit"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION CorkscrewJointAngle CDECL LIB "N3xtD.dll" ALIAS "_CorkscrewJointAngle"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION CorkscrewJointVeloc CDECL LIB "N3xtD.dll" ALIAS "_CorkscrewJointVeloc"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION CorkscrewJointOmega CDECL LIB "N3xtD.dll" ALIAS "_CorkscrewJointOmega"(BYVAL joint AS NJoint)AS SINGLE
DECLARE SUB CorkscrewJointForce CDECL LIB "N3xtD.dll" ALIAS "_CorkscrewJointForce"(BYVAL joint AS NJoint, force AS ANY)
DECLARE SUB UserCallbackUniversalJoint CDECL LIB "N3xtD.dll" ALIAS "_UserCallbackUniversalJoint"(BYVAL joint AS NJoint, CALLBACK_ AS ANY)
DECLARE FUNCTION UniversalJointAngle0 CDECL LIB "N3xtD.dll" ALIAS "_UniversalJointAngle0"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION UniversalJointAngle1 CDECL LIB "N3xtD.dll" ALIAS "_UniversalJointAngle1"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION UniversalJointOmega0 CDECL LIB "N3xtD.dll" ALIAS "_UniversalJointOmega0"(BYVAL joint AS NJoint)AS SINGLE
DECLARE FUNCTION UniversalJointOmega1 CDECL LIB "N3xtD.dll" ALIAS "_UniversalJointOmega1"(BYVAL joint AS NJoint)AS SINGLE
DECLARE SUB UniversalJointForce CDECL LIB "N3xtD.dll" ALIAS "_UniversalJointForce"(BYVAL joint AS NJoint, force AS ANY)
DECLARE SUB UpVectorGetPin CDECL LIB "N3xtD.dll" ALIAS "_UpVectorGetPin"(BYVAL joint AS NJoint, pin AS ANY)
DECLARE SUB SetPinUpVector CDECL LIB "N3xtD.dll" ALIAS "_SetPinUpVector"(BYVAL joint AS NJoint, pin AS ANY)
DECLARE SUB AddLinearRowUserJoint CDECL LIB "N3xtD.dll" ALIAS "_AddLinearRowUserJoint"(BYVAL joint AS NJoint, pivot0 AS ANY, pivot1 AS ANY, _
    dDir AS ANY)

DECLARE SUB AddAngularRowUserJoint CDECL LIB "N3xtD.dll" ALIAS "_AddAngularRowUserJoint"(BYVAL joint AS NJoint,  BYVAL relativeAngle AS SINGLE, dDir AS ANY)
DECLARE SUB AddGeneralRowUserJoint CDECL LIB "N3xtD.dll" ALIAS "_AddGeneralRowUserJoint"(BYVAL joint AS NJoint, jacobian0 AS ANY, jacobian1 AS ANY)
DECLARE SUB RowMinimumFrictionUserJoint CDECL LIB "N3xtD.dll" ALIAS "_RowMinimumFrictionUserJoint"(BYVAL joint AS NJoint, BYVAL  friction AS SINGLE)
DECLARE SUB RowMaximumFrictionUserJoint CDECL LIB "N3xtD.dll" ALIAS "_RowMaximumFrictionUserJoint"(BYVAL joint AS NJoint, BYVAL friction AS SINGLE)
DECLARE SUB RowAccelerationUserJoint CDECL LIB "N3xtD.dll" ALIAS "_RowAccelerationUserJoint"(BYVAL joint AS NJoint,  BYVAL acceleration AS SINGLE)
DECLARE SUB RowSpringDamperAccelerationUserJoint CDECL LIB "N3xtD.dll" ALIAS "_RowSpringDamperAccelerationUserJoint"(BYVAL joint AS NJoint, BYVAL  springK AS SINGLE, _
    BYVAL springD AS SINGLE)
DECLARE SUB RowStiffnessUserJoint CDECL LIB "N3xtD.dll" ALIAS "_RowStiffnessUserJoint"(BYVAL joint AS NJoint,  BYVAL stiffness AS SINGLE)
DECLARE FUNCTION UserJointRowForce CDECL LIB "N3xtD.dll" ALIAS "_UserJointRowForce"(BYVAL joint AS NJoint,  BYVAL ROW AS LONG)AS SINGLE

' ------------------------------------------------------------------------------------------------------------------------
'- MATERIAL IN CALLBACK
' ------------------------------------------------------------------------------------------------------------------------
DECLARE SUB PhysicMaterialEventCallBack CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialEventCallBack"(BYVAL pr AS NMaterialPair, materialCallBack AS ANY)
DECLARE SUB PhysicMaterialCallBackAABBOverlap CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialCallBackAABBOverlap"(BYVAL pr AS NMaterialPair, materialCallBack AS ANY)
DECLARE FUNCTION PhysicMaterialPairUserData CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialPairUserData"(BYVAL material AS NPMaterial)AS DWORD
DECLARE FUNCTION PhysicMaterialContactFaceAttribute CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialContactFaceAttribute"(BYVAL material AS NPMaterial)AS LONG
DECLARE FUNCTION PhysicMaterialBodyCollisionID CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialBodyCollisionID"(BYVAL material AS NPMaterial, BYVAL node AS EntityNode)AS LONG
DECLARE FUNCTION PhysicMaterialContactNormalSpeed CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialContactNormalSpeed"(BYVAL material AS NPMaterial)AS SINGLE
DECLARE SUB PhysicMaterialContactForce CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialContactForce"(BYVAL material AS NPMaterial, force AS ANY)
DECLARE SUB PhysicMaterialContactPositionAndNormal CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialContactPositionAndNormal"(BYVAL material AS NPMaterial, posit AS ANY, _
    normal AS ANY)

DECLARE SUB PhysicMaterialContactTangentDirections CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialContactTangentDirections"(BYVAL material AS NPMaterial, dir0 AS ANY, _
    dir1 AS ANY)

DECLARE FUNCTION PhysicMaterialContactTangentSpeed CDECL LIB "N3xtD.dll" ALIAS "_PhysicMaterialContactTangentSpeed"(BYVAL material AS NPMaterial,  BYVAL index AS LONG)AS SINGLE
DECLARE SUB ContactSoftnessPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactSoftnessPhysicMaterial"(BYVAL material AS NPMaterial,  BYVAL softness AS SINGLE)
DECLARE SUB ContactElasticityPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactElasticityPhysicMaterial"(BYVAL material AS NPMaterial,  BYVAL restitution AS SINGLE)
DECLARE SUB ContactFrictionStatePhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactFrictionStatePhysicMaterial"(BYVAL material AS NPMaterial,  BYVAL STATE AS LONG, _
    BYVAL index AS LONG)

DECLARE SUB ContactFrictionCoefPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactFrictionCoefPhysicMaterial"(BYVAL material AS NPMaterial,  BYVAL staticFrictionCoef AS SINGLE,_
    BYVAL kineticFrictionCoef AS SINGLE,  BYVAL index AS LONG)

DECLARE SUB ContactNormalAccelerationPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactNormalAccelerationPhysicMaterial"(BYVAL material AS NPMaterial,  BYVAL ACCEL AS SINGLE)
DECLARE SUB ContactNormalDirectionPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactNormalDirectionPhysicMaterial"(BYVAL material AS NPMaterial, directionVector AS ANY)
DECLARE SUB ContactTangentAccelerationPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactTangentAccelerationPhysicMaterial"(BYVAL material AS NPMaterial,  BYVAL ACCEL AS SINGLE,  BYVAL index AS LONG)
DECLARE SUB ContactRotateTangentDirectionsPhysicMaterial CDECL LIB "N3xtD.dll" ALIAS "_ContactRotateTangentDirectionsPhysicMaterial"(BYVAL material AS NPMaterial, directionVector AS ANY)
